#
# k2htpmdtor for K2HASH MULTI TRANSACTION PLUGIN.
#
# Copyright 2016 Yahoo Japan Corporation.
#
# K2HASH TRANSACTION PLUGIN is programmable I/F for processing
# transaction data from modifying K2HASH data.
#
# For the full copyright and license information, please view
# the license file that was distributed with this source code.
#
# AUTHOR:   Takeshi Nakatani
# CREATE:   Mon Dec 19 2016
# REVISION:
#

#
# Local macros/define
#
%if %{undefined package_revision}
%global package_revision 1
%endif

%if %{undefined make_build}
%global make_build %{__make} %{?_smp_mflags}
%endif

%if %{undefined autosetup}
%global autosetup %setup -q
%endif

%global gittag v1.0.3

%if %{undefined make_check}
%global make_check 1
%endif

#
# main package
#
Summary: Shared library for K2HASH MULTI TRANSACTION PLUGIN.
Name: k2htpmdtor
Version: 1.0.3
Release: %{package_revision}%{?dist}
License: MIT
Group: Applications/Databases
URL: https://github.com/yahoojapan/k2htpmdtor
Source0: https://github.com/yahoojapan/k2htpmdtor/archive/%{gittag}/%{name}-%{version}.tar.gz
Requires: libfullock%{?_isa} >= 1.0.35, k2hash%{?_isa} >= 1.0.69, chmpx%{?_isa} >= 1.0.67
BuildRequires: git-core gcc-c++ make libtool libfullock-devel >= 1.0.35, k2hash-devel >= 1.0.69, chmpx-devel >= 1.0.67

%description
k2htpmdtor shared library is transaction plugin for k2hash library. The
k2hash library has programmable I/F for processing transaction data
from modifying K2HASH data.

k2hash library can load only one transaction plugin library. k2htpm-
dotr can transfer transaction data from k2hash library to multiple
k2hash transaction plugins. Using k2htpmdtor, you can execute multiple
transaction plugin shared library at same time by each transaction.

The k2htpmdtor need to get only one parameter for working. The basi-
cally parameter is the configuration file path or json string. This
configuration has multiple transaction plugin entries.

The k2hmdtor configuration must have K2HTPMDTOR, K2HTPMDTOR_TP section.

%prep
%autosetup -n %{name}-%{version}

%build
./autogen.sh
%configure --disable-static 
%make_build

%install
%make_install
find %{buildroot} -name '*.la' -exec rm -f {} ';'
find %{buildroot} -name '*.so' -exec rm -f {} ';'

%if %{make_check}
%check
%{__make} check
%endif

%if %{defined ldconfig_scriptlets}
%ldconfig_scriptlets
%else
%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig
%endif

%if 0%{?rhel} == 6
%clean
rm -rf %{buildroot}
%endif

%files
%if 0%{?rhel} == 6
%doc COPYING
%defattr(-,root,root)
%else
%license COPYING
%endif
%doc README AUTHORS ChangeLog
%{_libdir}/*.so.*
%{_mandir}/man3/*

%changelog
* Tue Nov 17 2020 Takeshi Nakatani <ggtakec@gmail.com>   1.0.3-1
- Switched Travis CI to Github actions and extended supported OS - #14
- Fixed bugs detected by cppcheck - #13

* Thu Jan 17 2019 Takeshi Nakatani <ggtakec@gmail.com>   1.0.2
- Updated README.md etc - #10

* Thu Jan 17 2019 Takeshi Nakatani <ggtakec@gmail.com>   1.0.1
- Fixed misspelling, and etc - #6
- Added check using cppcheck - #5
- Reflected the spelling check result for all sources - #4
- Fixed a wrong url - #1

* Tue Dec 11 2018 Hirotaka Wakabayashi <hiwakaba@yahoo-corp.jp>   1.0.0
- Initial Release on GitHub.
